import { IClientOptions, IClientPublishOptions, IClientSubscribeOptions } from 'mqtt';
import { Observable } from 'rxjs/Observable';
import { SubscriptionGrant } from '../models/subscription-grant';
import { ConnectionStatus } from '../models/connection-status';
export declare class MqttService {
    private _client;
    private _status;
    private _store;
    constructor(config: IClientOptions);
    subscribeTo<T>(topic: string, options?: IClientSubscribeOptions): Observable<(SubscriptionGrant | T)>;
    unsubscribeFrom(topic: string | Array<string>): Observable<any>;
    publishTo<T>(topic: string, message: T, options?: IClientPublishOptions): Observable<any>;
    end(force?: boolean, cb?: (...args) => void): void;
    status(): Observable<ConnectionStatus>;
    private removeTopic(topic);
    private updateTopic(topic, message);
    private addTopic<T>(topic, grant);
}
